# -*- coding: utf-8 -*-
import globalPluginHandler
import addonHandler
import ui
from time import sleep
from threading import Thread
from ctypes import windll, c_buffer, byref
import os.path
import winsound
addonHandler.initTranslation()
class GlobalPlugin(globalPluginHandler.GlobalPlugin):
	def __init__(self, *args, **kwargs):
		globalPluginHandler.GlobalPlugin.__init__(self, *args, **kwargs)
		self.dll=windll.winmm
		self.save_path=os.path.join(os.path.dirname(__file__), 'voice.wav')
	def script_microphone(self, gesture):
		Thread(target=self.func).start()
	def call(self, command):
		return self.dll.mciSendStringA(command.encode(), c_buffer(2550), 2550, 0)
	def func(self):
		res=self.call('open new type waveaudio alias voice wait')
		if res:
			ui.message('Error.')
			return
		res=self.call('set voice time format ms bitspersample 16 channels 2 samplespersec 44100 format tag pcm wait')
		if res:
			ui.message('Error.')
			return
		res=self.call('record voice')
		if res:
			ui.message('Error.')
			return
		ui.message('On.')
		sleep(10)
		res=self.call('stop voice wait')
		if res:
			ui.message('Error.')
			return
		res=self.call('save voice '+self.save_path+' wait')
		if res:
			ui.message('Error.')
			return
		res=self.call('close voice wait')
		if res:
			ui.message('Error.')
			return
		ui.message('Off, playing.')
		sleep(0.3)
		try:
			winsound.PlaySound(self.save_path, winsound.SND_FILENAME)
			ui.message('Done.')
		except RuntimeError:
			ui.message('Error.')
	__gestures={'kb:control+shift+\\':'microphone'}
